<?php
/*
  $Id: SmilePayfami.php,v 1.0.0.1 2003/07/03 12:00:03 odie Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com
  Copyright (c) 2002 osCommerce
  Released under the GNU General Public License

  Traditional Chinese language pack(Big5 code) for osCommerce 2.2 ms1
  Community: http://www.dcezgo.com 
  Author(s): Odie Chiou (odie@dcezgo.com)
  Released under the GNU General Public License ,too!!

*/

  class smilepayfami {
    var $code, $title, $description, $enabled;

// class constructor
    function smilepayfami() {
      global $order;

      $this->code = 'smilepayfami';
      $this->title = MODULE_PAYMENT_SMILEPAYFAMI_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_SMILEPAYFAMI_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_SMILEPAYFAMI_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_SMILEPAYFAMI_STATUS == 'True') ? true : false);
      
      if ((int)MODULE_PAYMENT_SMILEPAYFAMI_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_SMILEPAYFAMI_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();
	
	    $this->form_action_url = 'https://ssl.smse.com.tw/ezpos/mtmk_utf.asp';	//中文頁面 Chinese UTF Big5 PayPage
	    
            
    }

// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_SMILEPAYFAMI_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_SMILEPAYFAMI_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
    $selection = array('id' => $this->code,
                       'module' => $this->title,
                       'fields' => array(array('title' => MODULE_PAYMENT_SMILEPAYFAMI_PAYER_NAME,),));
     return $selection;   
    }

    function pre_confirmation_check() {
    global $order,$HTTP_POST_VARS;
    $DealerCode=MODULE_PAYMENT_SMILEPAYFAMI_ID;   
      if ( $order->info[total] < 0 || empty($DealerCode)) {
    		  $result = false ;
    		  $error = 1 ;
    		  $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error) ;
    		  tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
	    } else {
		      $result = true ;
	    }
	    return $result ;
    }
    function confirmation() {
      return array('title' => MODULE_PAYMENT_SMILEPAYFAMI_TEXT_CONFIRMATION);
    }


    function process_button() {
      global $order ,$mid ;           
  	  if ( $_SESSION['step'] == "" ) {
  			$_SESSION['step'] = 1 ;
  	  } else {
  			$_SESSION['step']++ ;
  	  }
    	//訂單編號計算
    	$oid_query =tep_db_query("select orders_id CNT from " . TABLE_ORDERS . " ORDER BY orders_id DESC LIMIT 1" );   	  
  	  $oid_array = tep_db_fetch_array($oid_query);  
 	    $oid_array=$oid_array['CNT']+1;
	    $oid = date('dHis')."-".$oid_array;

  	  $DealerCode=MODULE_PAYMENT_SMILEPAYFAMI_ID;
  	  if ($DealerCode=="") {
			  $DealerCode = "9999999" ;			
	    }
  	  $encode=MODULE_PAYMENT_SMILEPAYFAMI_PASSCODE;   
    	$passcode=$DealerCode .$encode;
    	$passcode_in=sha1($passcode);              
      //地址-客戶姓名-消費項目      
      $street_address = $order->customer['state'] . $order->customer['city'] .  $order->customer['street_address'] ;
	    $customer=$order->customer['firstname'] .$order->customer['lastname'];      
      //$sname=STORE_NAME."_".$order->products[0]['name'];
      $sname=mb_substr($order->products[0]['name'],0,14,'utf-8');           
      //回傳respond位置  
      $re=trim(MODULE_PAYMENT_SMILEPAYFAMI_RETUREURL);
      if (!empty($re)) {
            $roturl= MODULE_PAYMENT_SMILEPAYFAMI_RETUREURL ; 
      }else{
        $locallink=( ENABLE_SSL ?  'https://' : 'http://' ) . $_SERVER['SERVER_NAME']. substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'],"/") + 1);
        $roturl=$locallink."smilepayrespond.php";     
      }
                                                                                      
      //post表單
      $process_button_string = tep_draw_hidden_field('Dcvc', $DealerCode) .
                              tep_draw_hidden_field('Rvg2c', "1") .              
                              tep_draw_hidden_field('Amount', urlencode(round($order->info[total]))) .
                              tep_draw_hidden_field('Remark', $passcode_in) .                              
                              tep_draw_hidden_field('Data_id', $oid . "-" . substr(($_SESSION['step']+100),1)) .
                              tep_draw_hidden_field('Od_sob', $sname).
                              tep_draw_hidden_field('Pur_name', $customer).
                              tep_draw_hidden_field('Address', $street_address).
                              tep_draw_hidden_field('Email',$order->customer['email_address']).
                              tep_draw_hidden_field('Mobile_pur',$order->customer['fax']).
                              tep_draw_hidden_field('Pay_zg',"6").
                              tep_draw_hidden_field('Pay_gdry',"TW").
                              tep_draw_hidden_field('Tel_number',$order->customer['telephone']).
                              tep_draw_hidden_field('Roturl_status',"oscok").                              
                              tep_draw_hidden_field('Roturl', $roturl) .                                                                                                 
                              tep_draw_hidden_field('osCsid', tep_session_id());
                                 
      return $process_button_string;
    }

    function before_process() {
        return false;
    }

    function after_process() {
  	global $insert_id,$db,$cart ;
		$_SESSION['PAYMENTOID'] = $_POST['Data_id'] ;     		
		tep_db_query("update ".TABLE_ORDERS." set cc_owner='".$_SESSION['AUTHCODE']."', cc_number ='".$_SESSION['PAYMENTOID']."' where orders_id='".(int)$insert_id ."'");
    $cart->reset(true);		
		unset($_SESSION['AUTHCODE']) ;
		unset($_SESSION['PAYMENTOID']) ;
		unset($_SESSION['step']) ;     
      return true;
    }
    function respond(){
      $mitycat_type       = $_POST['Classif'];
      $mitycat_order      = $_POST['Data_id'];
      $amount             = $_POST['Amount']; 
      $passcode_in        = $_POST['Remark'];
      $smseid             = $_REQUEST['Smseid'];  
      $mid_smilepay       = $_POST['Mid_smilepay'];   

  	  $DealerCode=MODULE_PAYMENT_SMILEPAYFAMI_ID;
  	  $encode=MODULE_PAYMENT_SMILEPAYFAMI_PASSCODE;   
    	$passcode=$DealerCode .$encode;
      $passcode_ou=sha1($passcode); 
      
            //checksum Mid and Mid_smilepay from SmielPay    
      $mid=MODULE_PAYMENT_SMILEPAYFAMI_MID;
      $mid_value=MODULE_PAYMENT_SMILEPAYFAMI_MID_VALUE;
                               
      if($mid == 'True'){                         
        if(!$this->midfun($mid_value,$amount,$smseid,$mid_smilepay)){      
          echo  "Possible fraud";
          exit();
        }        
      }       
              
      if(($passcode_in == $passcode_ou && !empty($amount))&& ($mitycat_type == 'F' || $mitycat_type == 'L')){
      $mitycat_transnum   = "追蹤碼:".$smseid;
      $orders_status=MODULE_PAYMENT_SMILEPAYFAMI_ORDERED_STATUS_ID;  
      $comments='paid';
      $oID=explode ("-", $mitycat_order);
      tep_db_query("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added, customer_notified, comments) values ('" . (int)$oID[1] . "', '" .$orders_status . "', now(), '', '".$mitycat_transnum."')");
      tep_db_query("update " . TABLE_ORDERS . " set cc_type = '" . $mitycat_transnum . "',orders_status='".$orders_status."',last_modified = now(),cc_expires ='".$comments."'  where cc_number = '" . $mitycat_order . "'");        
        return "oscok";
      }
      else {        
        return false;
      }
    }
    function get_error() {
	  switch ($_GET['error']) {
		  case 1 :
		  	$error_message = MODULE_PAYMENT_SMILEPAYFAMI_TEXT_ERROR_1 ;
		  break ;
		  case 2 :
		  	$error_message = MODULE_PAYMENT_SMILEPAYFAMI_TEXT_ERROR_2 ;
		  break ;
	  }
      $error = array('title' => MODULE_PAYMENT_SMILEPAYFAMI_TEXT_ERROR,
                     'error' => $error_message );
      return $error;
    }

    function output_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SMILEPAYFAMI_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('啟動 SmilePay 全家 FamiPort / 萊爾富Life ET 代碼繳費模組', 'MODULE_PAYMENT_SMILEPAYFAMI_STATUS', 'True', '接受 SmilePay 全家 FamiPort / 萊爾富Life ET 代碼繳費結帳？', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('SmilePay 商家編號', 'MODULE_PAYMENT_SMILEPAYFAMI_ID', '', '請輸入 SmilePay 訊航科技 商家編號(測試請留空白)', '6', '4', now())");      
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('設定加密字串', 'MODULE_PAYMENT_SMILEPAYFAMI_PASSCODE', '', '請輸入加密字串', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('SmilePay 全家 FamiPort / 萊爾富Life ET 代碼繳費結帳的顯示順序', 'MODULE_PAYMENT_SMILEPAYFAMI_SORT_ORDER', '0', 'SmilePay 結帳的顯示順序，數字小者在前', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('SmilePay 全家 FamiPort / 萊爾富Life ET 代碼繳費付費結帳地區', 'MODULE_PAYMENT_SMILEPAYFAMI_ZONE', '0', '如果選擇地區，則只有該地區可以使用這個結帳方式', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('SmilePay 全家 FamiPort / 萊爾富Life ET 代碼繳費付費預設訂單狀態', 'MODULE_PAYMENT_SMILEPAYFAMI_ORDER_STATUS_ID', '0', '設定使用 SmilePay 全家 FamiPort / 萊爾富Life ET 代碼繳費付費時，預設的訂單狀態', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('客戶付費完成銷帳訂單狀態', 'MODULE_PAYMENT_SMILEPAYFAMI_ORDERED_STATUS_ID', '0', '設定消費者付費完成時，銷帳的訂單狀態', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");      
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('SmilePay 全家 FamiPort / 萊爾富Life ET 代碼繳費付費完成回傳網址', 'MODULE_PAYMENT_SMILEPAYFAMI_RETUREURL', '', '如無特別需要請留空白', '6', '6', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('啟用商家驗證參數', 'MODULE_PAYMENT_SMILEPAYFAMI_MID', 'False', '驗證付款完成資料，是否由SmilePay回送', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");      
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('商家驗證參數', 'MODULE_PAYMENT_SMILEPAYFAMI_MID_VALUE', '', '請與SmilePay後台->基本資料管理->商家驗證參數 相同', '6', '6', now())");      
           
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_SMILEPAYFAMI_STATUS', 'MODULE_PAYMENT_SMILEPAYFAMI_ID','MODULE_PAYMENT_SMILEPAYFAMI_PASSCODE', 'MODULE_PAYMENT_SMILEPAYFAMI_RETUREURL', 'MODULE_PAYMENT_SMILEPAYFAMI_ZONE', 'MODULE_PAYMENT_SMILEPAYFAMI_ORDER_STATUS_ID', 'MODULE_PAYMENT_SMILEPAYFAMI_SORT_ORDER','MODULE_PAYMENT_SMILEPAYFAMI_ORDERED_STATUS_ID','MODULE_PAYMENT_SMILEPAYFAMI_MID','MODULE_PAYMENT_SMILEPAYFAMI_MID_VALUE');
    }
        // compute Mid      
    function midfun($Mid_value,$Amount,$Smseid,$Mid_smilepay){   
      $Amount = str_pad($Amount,8,'0',STR_PAD_LEFT);                   
      $Smseid= preg_replace('/[\D]/i','9',substr($Smseid,-4));      
      $dtotal=$Mid_value. $Amount. $Smseid;                              
      
      $i = 1;
      $sum = strlen($dtotal);
      $etemp=0;      
      while ($i <= $sum)
      {
        $ep = substr($dtotal,$i,1);
        $etemp = $etemp + $ep;                
        $i=$i+2;
      }                
      
      $i = 0;  
      $otemp=0;          
      while ($i <= $sum)
      {                                              
        $op = substr($dtotal,$i,1);
        $otemp = $otemp + $op;
        $i=$i+2;
      } 
      
      $mid=($etemp*3)+($otemp*9);
    
      if($Mid_smilepay == $mid){
        return true;
      }else{
        return false;
      }
         
    }  
  }
?>
